;;; -*- Mode: LISP; Syntax: COMMON-LISP; Package: ALPINE; Base: 10 -*-
;;;
;;;  (c) copyright 2007-2008 by
;;;           Samium Gromoff (_deepfire@feelingofgreen.ru)
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Library General Public
;;; License as published by the Free Software Foundation; either
;;; version 2 of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Library General Public License for more details.
;;;
;;; You should have received a copy of the GNU Library General Public
;;; License along with this library; if not, write to the
;;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;;; Boston, MA  02111-1307  USA.

(in-package :alpine)

(defparameter *name-cuteing-map* (make-hash-table :test 'equal))

(defparameter *name-cuteing-map-source*
  '(("Александр" "Саша")
    ("Анна" "Аня")
    ("Валерия" "Лера")
    ("Виктор" "Витя")
    ("Виктория" "Вика")
    ("Виталий" "Виталик")
    ("Владимир" "Вова")
    ("Дарья" "Даша")
    ("Дмитрий" "Дима")
    ("Евгений" "Женя")
    ("Елена" "Лена")
    ("Катерина" "Катя")
    ("Константин" "Костя")
    ("Леонид" "Лёня")
    ("Мария" "Маша")
    ("Михаил" "Миша")
    ("Наталья" "Наташа")
    ("Ольга" "Оля")
    ("Павел" "Паша")
    ("Светлана" "Света")
    ("Сергей" "Серёжа")
    ("Юлия" "Юля")))

(iter (for (k v) in *name-cuteing-map-source*)
      (setf (gethash k *name-cuteing-map*) v))

(defun cute-name (name)
  (or (gethash name *name-cuteing-map*)
      name))